import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;

public class KCtrlSKK extends KCtrl implements KConstant {

	/**
	 * フェーズ.
	 */
	private final int PHASE_INIT		= 0;
	private final int PHASE_TITLE		= 1;
	private final int PHASE_RUN			= 2;
	private final int PHASE_BOMB		= 3;
	private final int PHASE_END			= 4;
	private final int PHASE_STOP		= -1;

	/**
	 * パネル.
	 */
	private		KPanel				panel				= null;

	/**
	 * イメージ.
	 */
	private		BufferedImage		imageBackground		= null;
	private		BufferedImage		imageTitle			= null;
	private		BufferedImage		imageShip			= null;
	private		BufferedImage		imageShipMini		= null;
	private		BufferedImage		imageBeam1			= null;
	private		BufferedImage		imageB01			= null;
	private		BufferedImage		imageB02			= null;
	private		BufferedImage		imageS01			= null;
	private		BufferedImage		imageS02			= null;
	private		BufferedImage		imageS03			= null;
	private		BufferedImage		imageS04			= null;
	private		BufferedImage		imageT01			= null;
	private		BufferedImage		imageT02			= null;
	private		BufferedImage		imageT03			= null;
	private		BufferedImage		imageT04_00			= null;
	private		BufferedImage		imageT04_01			= null;
	private		BufferedImage		imageT04_02			= null;
	private		BufferedImage		imageT05_00			= null;
	private		BufferedImage		imageT05_01			= null;
	private		BufferedImage		imageT05_02			= null;
	private		BufferedImage		imageT05_03			= null;
	private		BufferedImage		imageT06			= null;
	private		BufferedImage		imageT07_00			= null;
	private		BufferedImage		imageT07_01			= null;
	private		BufferedImage		imageT07_02			= null;
	private		BufferedImage		imageT07_03			= null;
	private		BufferedImage		imageT07_04			= null;
	private		BufferedImage		imageT07_05			= null;
	private		BufferedImage		imageT07_06			= null;
	private		BufferedImage		imageT07_07			= null;
	private		BufferedImage		imageT08_00			= null;
	private		BufferedImage		imageT08_01			= null;
	private		BufferedImage		imageT09			= null;
	private		BufferedImage		imageT99			= null;
	private		BufferedImage		imageJ01			= null;
	private		BufferedImage		imageJ02			= null;
	private		BufferedImage		imageJ03_00			= null;
	private		BufferedImage		imageJ03_01			= null;
	private		BufferedImage		imageSUSI01			= null;
	private		BufferedImage		imageSUSI02			= null;
	private		BufferedImage		imageSUSI03			= null;

	/**
	 * スプライト.
	 * 全体的に表示等されるスプライトは、ここで管理する。
	 */
	private		KSpriteBackground	spriteBackground0	= null;
	private		KSpriteBackground	spriteBackground1	= null;
	private		KSpriteTitle		spriteTitle			= null;
	private		KSpriteShip			spriteShip			= null;
	private		KSpriteShipMini		spriteShipMini		= null;

	/**
	 * テキスト.
	 */
	private		KText				kTextStart			= null;
	private		KText				kTextBy				= null;
	private		KText				kTextEnd			= null;
	private		KText				kTextScoreHigh		= null;
	private		KText				kTextScore			= null;
	private		KTextShield			kTextShield			= null;
	private		KText				kTextStage			= null;
	private		KText				kTextTime			= null;

	/**
	 * フェーズ.
	 */
	private		int					phase				= PHASE_INIT;

	/**
	 * ストーリー.
	 */
	private		KStorySKK			kStorySKK			= null;

	/**
	 * スコア.
	 */
	private		int					score				= 0;

	/**
	 * ハイスコア.
	 */
	private		int					scoreHigh			= 50000;

	/**
	 * ステージ.
	 */
	private		int					stage				= 1;

	/**
	 * 防御.
	 */
	private		int					shield				= 5;
	/**
	 * 防御.
	 */
	private		String				strShield			= "■■■■■";

	/**
	 * 撃墜してからの時間.
	 */
	private		int					timeBomb			= 0;

	/**
	 * コンストラクタ.
	 * @param con コンテナ
	 */
	public KCtrlSKK(Container con){

		super(con);

		try{

			// パネルを生成
			panel = new KPanel(this);

			// スプライト層の数を設定
			panel.setLayoutCount(LAYOUT_COUNT);

			// ストーリークラスを生成
			kStorySKK = new KStorySKK(panel);

			// イメージを取得
			imageBackground = KImage.getImage("imageBackground.gif");
			imageTitle = KImage.getImage("imageTitle.gif");
			imageShip = KImage.getImage("imageShip.gif");
			imageShipMini = KImage.getImage("imageShipMini.gif");
			imageBeam1 = KImage.getImage("imageBeam1.gif");
			imageB01 = KImage.getImage("imageBomb1.gif");
			imageB02 = KImage.getImage("imageBomb2.gif");
			imageS01 = KImage.getImage("imageS01.gif");
			imageS02 = KImage.getImage("imageS02.gif");
			imageS03 = KImage.getImage("imageS03.gif");
			imageS04 = KImage.getImage("imageS04.gif");
			imageT01 = KImage.getImage("imageT01.gif");
			imageT02 = KImage.getImage("imageT01.gif");
			imageT03 = KImage.getImage("imageT03.gif");
			imageT04_00 = KImage.getImage("imageT04_00.gif");
			imageT04_01 = KImage.getImage("imageT04_01.gif");
			imageT04_02 = KImage.getImage("imageT04_02.gif");
			imageT05_00 = KImage.getImage("imageT05_00.gif");
			imageT05_01 = KImage.getImage("imageT05_01.gif");
			imageT05_02 = KImage.getImage("imageT05_02.gif");
			imageT05_03 = KImage.getImage("imageT05_03.gif");
			imageT06 = KImage.getImage("imageT06.gif");
			imageT07_00 = KImage.getImage("imageT07_00.gif");
			imageT07_01 = KImage.getImage("imageT07_01.gif");
			imageT07_02 = KImage.getImage("imageT07_02.gif");
			imageT07_03 = KImage.getImage("imageT07_03.gif");
			imageT07_04 = KImage.getImage("imageT07_04.gif");
			imageT07_05 = KImage.getImage("imageT07_05.gif");
			imageT07_06 = KImage.getImage("imageT07_06.gif");
			imageT07_07 = KImage.getImage("imageT07_07.gif");
			imageT08_00 = KImage.getImage("imageT08_00.gif");
			imageT08_01 = KImage.getImage("imageT08_01.gif");
			imageT09 = KImage.getImage("imageT09.gif");
			imageJ01 = KImage.getImage("imageJ01.gif");
			imageJ02 = KImage.getImage("imageJ02.gif");
			imageJ03_00 = KImage.getImage("imageJ03_00.gif");
			imageJ03_01 = KImage.getImage("imageJ03_01.gif");
			imageT99 = KImage.getImage("imageT99.gif");
			imageSUSI01 = KImage.getImage("imageSUSI01.gif");
			imageSUSI02 = KImage.getImage("imageSUSI02.gif");
			imageSUSI03 = KImage.getImage("imageSUSI03.gif");

			// イメージをスプライトに登録する
			KSpriteBackground.setImage(KSpriteBackground.class, imageBackground);
			KSpriteTitle.setImage(KSpriteTitle.class, imageTitle);
			KSpriteShip.setImage(KSpriteShip.class, new BufferedImage[]{imageShip, imageB01, imageB02});
			KSpriteShipMini.setImage(KSpriteShipMini.class, imageShipMini);
			KSpriteBeam1.setImage(KSpriteBeam1.class, imageBeam1);
			KSpriteS01.setImage(KSpriteS01.class, imageS01);
			KSpriteS02.setImage(KSpriteS02.class, imageS02);
			KSpriteS03.setImage(KSpriteS03.class, imageS03);
			KSpriteS04.setImage(KSpriteS04.class, imageS04);
			KSpriteT00.setImage(KSpriteT00.class, new BufferedImage[]{imageB01, imageB02});
			KSpriteT01.setImage(KSpriteT01.class, imageT01);
			KSpriteT02.setImage(KSpriteT02.class, imageT02);
			KSpriteT03.setImage(KSpriteT03.class, imageT03);
			KSpriteT04.setImage(KSpriteT04.class, new BufferedImage[]{imageT04_00, imageT04_01, imageT04_02});
			KSpriteT05.setImage(KSpriteT05.class, new BufferedImage[]{imageT05_00, imageT05_01, imageT05_02, imageT05_03});
			KSpriteT06.setImage(KSpriteT06.class, imageT06);
			KSpriteT07.setImage(KSpriteT07.class, new BufferedImage[]{imageT07_00, imageT07_01, imageT07_02, imageT07_03, imageT07_04, imageT07_05, imageT07_06, imageT07_07});
			KSpriteT08.setImage(KSpriteT08.class, new BufferedImage[]{imageT08_00, imageT08_01});
			KSpriteT09.setImage(KSpriteT09.class, imageT09);
			KSpriteT99.setImage(KSpriteT99.class, imageT99);
			KSpriteJ01.setImage(KSpriteJ01.class, imageJ01);
			KSpriteJ02.setImage(KSpriteJ02.class, imageJ02);
			KSpriteJ03.setImage(KSpriteJ03.class, new BufferedImage[]{imageJ03_00, imageJ03_01});
			KSpriteSUSI01.setImage(KSpriteSUSI01.class, imageSUSI01);
			KSpriteSUSI02.setImage(KSpriteSUSI02.class, imageSUSI02);
			KSpriteSUSI03.setImage(KSpriteSUSI03.class, imageSUSI03);

			// スプライト生成
			spriteBackground0 = new KSpriteBackground(panel);
			spriteBackground1 = new KSpriteBackground(panel);
			spriteTitle = new KSpriteTitle(panel);
			spriteShip = new KSpriteShip(panel);
			spriteShipMini = new KSpriteShipMini(panel);

			// 背景を登録
			panel.addSprite(LAYOUT_HOSI, spriteBackground0);
			panel.addSprite(LAYOUT_HOSI, spriteBackground1);

			// 各テキストを生成
			kTextStart = new KText(panel, 215, 400);
			kTextStart.setFont(new Font("HG丸ｺﾞｼｯｸM-PRO", Font.PLAIN, 16));
			kTextStart.setText("PUSH SPACE KEY");

			kTextBy = new KText(panel, 230, 520);
			kTextBy.setFont(new Font("ＭＳ ゴシック", Font.PLAIN, 12));
			kTextBy.setText("PROGRAMED  BY  KIN");

			kTextEnd = new KText(panel, 250, 300);
			kTextEnd.setFont(new Font("HG丸ｺﾞｼｯｸM-PRO", Font.PLAIN, 16));
			kTextEnd.setText("GAME OVER");

			kTextScoreHigh = new KText(panel, 50, 20);
			panel.addText("HIGH-SCORE", kTextScoreHigh);

			kTextScore = new KText(panel, 200, 20);
			panel.addText("SCORE", kTextScore);

			kTextShield = new KTextShield(panel, 350, 20);
			panel.addText("SHIP", kTextShield);

			kTextStage = new KText(panel, 500, 20);
			panel.addText("STAGE", kTextStage);

			kTextTime = new KText(panel, 500, 40);
			panel.addText("TIME", kTextTime);

			// 残機スプライトの設定
			spriteShipMini.setX(320);
			spriteShipMini.setY(4);

			// 背景に切れ目ができないように設定
			spriteBackground1.setY(-600);

		// エラーの場合、
		}catch(Exception ex){
			// スタックトレース出力
			ex.printStackTrace();
			// エラーを表示
			JOptionPane.showMessageDialog(null, ex.toString());
		}

	} // end KCtrlSKK

	/**
	 * 開始.
	 * <pre>
	 * 当オブジェクトの処理を開始します。
	 * <pre>
	 */
	public void start(){

		// パネルにフォーカスを当てる
		panel.requestFocus();

		// パネルを開始する
		panel.start();

		// 初期化フェーズへ
		this.phase = PHASE_INIT;

	} // end start

	/**
	 * 実行.
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// フェーズ分け
		switch(this.phase){

			// 初期化フェーズ
			case PHASE_INIT:

				// スコア
				score = 0;

				// ステージ
				stage = 1;

				// 防御
				shield = 5;
				strShield = "■■■■■";

				// 撃墜時間
				timeBomb = 0;

				// ストーリをリセット
				kStorySKK.reset();

				// 自機のスプライト層を初期化
				panel.initKSpriteLstInLayout(LAYOUT_JIBUN);

				// 地面のスプライト層を初期化
				panel.initKSpriteLstInLayout(LAYOUT_JIMEN);

				// 敵のスプライト層を初期化
				panel.initKSpriteLstInLayout(LAYOUT_TEKI);

				// スプライトグループ初期化
				panel.initSpriteGroup();

				// タイトル表示
				panel.addSprite(LAYOUT_JIMEN, spriteTitle);
				panel.addText("START", kTextStart);
				panel.addText("BY", kTextBy);

				// スコア初期化
				kTextScore.setText("SCORE : " + Integer.toString(score));

				this.phase = PHASE_TITLE;

				break;

			// タイトル画面フェーズ
			case PHASE_TITLE:

				// ハイスコア設定
				kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

				// スペースが押された場合、
				if(panel.isKeyCodePressed(KeyEvent.VK_SPACE)){

					// タイトルを削除
					panel.removeSprite(LAYOUT_JIMEN, spriteTitle);
					panel.removeText("START");
					panel.removeText("BY");

					// 自機を生成
					spriteShip = new KSpriteShip(panel);

					// 自機を初期化
					spriteShip.init();

					// 自機スプライトを登録
					panel.addSprite(LAYOUT_JIBUN, spriteShip);
					// 残機スプライトを登録
					panel.addSprite(LAYOUT_JIBUN, spriteShipMini);

					// ストーリーを進める
					kStorySKK.start();

					// 通常フェーズへ
					this.phase = PHASE_RUN;

				}

				break;

			// 通常フェーズ
			case PHASE_RUN:

				//
				// ストーリーを進める
				//
				kStorySKK.next();

				// 各テキストを最新化
				kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

				kTextScore.setText("SCORE : " + Integer.toString(score));

				kTextStage.setText("STAGE : " + Integer.toString(stage));

				kTextTime.setText("TIME : " + kStorySKK.getStoryTime());

				kTextShield.setText(strShield);

				break;

			// 撃墜フェーズ
			case PHASE_BOMB:

				//
				// ストーリーを進める
				//
				kStorySKK.next();

				// 各テキストを最新化
				kTextTime.setText("TIME : " + kStorySKK.getStoryTime());

				kTextShield.setText(strShield);

				// 撃墜時間を進める
				timeBomb++;

				// 時間が経った場合、
				if(timeBomb > 200){

					// ゲームオーバーフェーズへ
					phase = PHASE_END;

					panel.addText("END", kTextEnd);

				}

				break;

			// ゲームオーバーフェーズへ
			case PHASE_END:

				//
				// ストーリーを進める
				//
				kStorySKK.next();

				// 各テキストを最新化
				kTextTime.setText("TIME : " + kStorySKK.getStoryTime());

				// 撃墜時間を進める
				timeBomb++;

				// 時間が経った場合、
				if(timeBomb > 500){

					panel.removeText("END");

					// 初期化フェーズへ
					phase = PHASE_INIT;

				}

				break;

			default:
				break;

		} // end switch フェーズ分け

	} // end run

	/**
	 * スコア加算.
	 * <pre>
	 * スコア加算する場合は、呼び出してください。
	 * </pre>
	 * @param scoreAdd 追加する点数
	 */
	public void addScore(int scoreAdd){

		this.score = this.score + scoreAdd;

		this.scoreHigh = (this.score > this.scoreHigh)?this.score: this.scoreHigh;

		kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

		kTextScore.setText("SCORE : " + Integer.toString(score));

	} // end addScore

	/**
	 * スコア取得.
	 * @return int スコア
	 */
	public int getScore(){

		return this.score;

	} // end getScore

	/**
	 * 防御加減算.
	 * <pre>
	 * プラスもマイナスも処理します。
	 * 0になったら、ゲームオーバーです。
	 * </pre>
	 * @param shieldAdd 加減算する数
	 * @return 加減算した後の防御数
	 */
	public int addShield(int shieldAdd){

		// 防御加減算
		this.shield = this.shield + shieldAdd;

		StringBuilder sb = new StringBuilder();

		// 防御テキストを作成しなおす
		for(int i = 0; i < this.shield; i++){
			sb.append("■");
		}

		strShield = sb.toString();

		// ダメージを受けた場合（受けた影響が−１以下の場合）、
		if(shieldAdd < 0){
			// 色を変更する
			kTextShield.damage();
		}

		// 防御が０になった場合、
		if(this.shield == 0){
			// 撃墜フェーズへ
			phase = PHASE_BOMB;
		}

		// 加減算した後の防御数をリターン
		return this.shield;

	} // end addScore

	/**
	 * 防御取得.
	 * <pre>
	 * </pre>
	 * @return int 防御数
	 */
	public int getShield(){

		return this.shield;

	} // end getShield

	/**
	 * フェーズ再開.
	 */
	public void restart(){

		// ゲームオーバー中の場合、
		if(this.phase == PHASE_BOMB || this.phase == PHASE_END){

			// 何もしない

		// 上記以外の場合、
		}else{

			// フェーズ再開
			this.phase = PHASE_RUN;

		}

	}

	/**
	 * フェーズ停止.
	 */
	public void stop(){

		// フェーズ停止
		this.phase = PHASE_STOP;

	}

	/**
	 * ステージ取得.
	 */
	public int getStage(){

		// ステージをリターン
		return this.stage;

	}

	/**
	 * ステージ＋１.
	 */
	public void addStage(){

		// ステージを＋１
		this.stage++;

	}

	/**
	 * パネル取得.
	 * @return KPanel パネル
	 */
	public KPanel getKPanel(){

		// パネルをリターン
		return this.panel;

	}

	/**
	 * ゲームオーバー.
	 */
	public void gameover(){

		// フェーズ変更
		phase = PHASE_END;

		panel.addText("END", kTextEnd);

	} // end gameover

}
